#include "../headers.h"

BoundingBox::BoundingBox()
{
	plane[LEFT].normal.x   = -1;
	plane[LEFT].normal.y   =  0;
	plane[LEFT].normal.z   =  0;

	plane[RIGHT].normal.x  =  1;
	plane[RIGHT].normal.y  =  0;
	plane[RIGHT].normal.z  =  0;

	plane[TOP].normal.x    =  0;
	plane[TOP].normal.y    =  1;
	plane[TOP].normal.z    =  0;

	plane[BOTTOM].normal.x =  0;
	plane[BOTTOM].normal.y = -1;
	plane[BOTTOM].normal.z =  0;

	plane[FRONT].normal.x  =  0;
	plane[FRONT].normal.y  =  0;
	plane[FRONT].normal.z  = -1;

	plane[BACK].normal.x   =  0;
	plane[BACK].normal.y   =  0;
	plane[BACK].normal.z   =  1;

	boxType = BOX_SOLID;
}

BoundingBox::~BoundingBox()
{
}

void BoundingBox::update(Vector position)
{
	Vector point1;

	/* Calculate Distance for Left Face */

	point1.x = position.x + mins.x;
	point1.y = position.y + maxs.y;
	point1.z = position.z + maxs.z;

	plane[LEFT].d = Geometry::getPlaneDistance(plane[LEFT].normal, point1);

	/* Calculate Distance for Right Face */

	point1.x = position.x + maxs.x;
	point1.y = position.y + maxs.y;
	point1.z = position.z + mins.z;

	plane[RIGHT].d = Geometry::getPlaneDistance(plane[RIGHT].normal, point1);

	/* Calculate Distance for Top Face */

	point1.x = position.x + mins.x;
	point1.y = position.y + maxs.y;
	point1.z = position.z + maxs.z;

	plane[TOP].d = Geometry::getPlaneDistance(plane[TOP].normal, point1);

	/* Calculate Distance for Bottom Face */

	point1.x = position.x + mins.x;
	point1.y = position.y + mins.y;
	point1.z = position.z + maxs.z;

	plane[BOTTOM].d = Geometry::getPlaneDistance(plane[BOTTOM].normal, point1);

	/* Calculate Distance for Front Face */

	point1.x = position.x + mins.x;
	point1.y = position.y + maxs.y;
	point1.z = position.z + mins.z;

	plane[FRONT].d = Geometry::getPlaneDistance(plane[FRONT].normal, point1);

	/* Calculate Distance for Back Face */

	point1.x = position.x + maxs.x;
	point1.y = position.y + maxs.y;
	point1.z = position.z + maxs.z;

	plane[BACK].d = Geometry::getPlaneDistance(plane[BACK].normal, point1);
}
