/*
Copyright (C) 2005 Parallel Realities

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "../headers.h"

Trigger::Trigger()
{
	thinkTime = rand() % 25;
	
	active = false;
	
	grouped = false;
	
	invisible = true;
	
	type = 0;

	radius = 3;
	
	action = 0;
	
	objectiveId = -1;
}

Trigger::~Trigger()
{
}

void Trigger::deactivate()
{
	if ((action != TRIGGER_ACTION_UPDATE_OBJECTIVE) && (action != TRIGGER_ACTION_FAIL_OBJECTIVE))
	{
		active = false;
	}
}

void Trigger::load(Properties *props)
{
	name = props->getString("name", name.getText());
	targetName = props->getString("targetName", targetName.getText());

	active = props->getInt("active", active);
	
	grouped = props->getInt("grouped", grouped);
	radius = props->getFloat("radius", radius);
	invisible = props->getFloat("invisible", invisible);

	objectiveId = props->getInt("objectiveId", objectiveId);

	position = props->getVector("position", position);
}

void Trigger::save(FILE *fp)
{
	Properties props;
	
	props.setName("Trigger");
	
	props.setProperty("name", name.getText());
	props.setProperty("targetName", targetName.getText());
	
	props.setProperty("thinkTime", thinkTime);
	props.setProperty("active", active);
	props.setProperty("type", type);
	
	props.setProperty("grouped", grouped);
	
	props.setProperty("radius", radius);
	props.setProperty("action", action);
	
	props.setProperty("objectiveId", objectiveId);
	
	props.save(fp);
}
