/*
Copyright (C) 2005 Parallel Realities

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "options.h"

void populateMouseControls()
{
	debug(("populateMouseControls()\n"));
	
	((InputWidget*)uiManager->getWidget("left", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_LEFT]);
	((InputWidget*)uiManager->getWidget("right", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_RIGHT]);
	((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_UP]);
	((InputWidget*)uiManager->getWidget("back", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_DOWN]);
	((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_FIRE]);
	((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_JUMP]);
	((InputWidget*)uiManager->getWidget("action", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_ACTION]);
	
	((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_QUICK_GRENADE]);
	((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_CYCLE_WEAPON]);
	((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_LOCK_TARGET]);
	((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_CYCLE_TARGET]);
	((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_ROTATE_LEFT]);
	((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->setValue(INPUT_MOUSE, game->mouseCtrl[CTRL_ROTATE_RIGHT]);
	
	((Slider*)uiManager->getWidget("mouseSensitivity", "controlConfig"))->value = 1000 - game->mouseSensitivity;
}

void populateJoystickControls()
{
	debug(("populateJoystickControls()\n"));
	
	((InputWidget*)uiManager->getWidget("left", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_LEFT]);
	((InputWidget*)uiManager->getWidget("right", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_RIGHT]);
	((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_UP]);
	((InputWidget*)uiManager->getWidget("back", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_DOWN]);
	((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_FIRE]);
	((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_JUMP]);
	((InputWidget*)uiManager->getWidget("action", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_ACTION]);
	
	((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_QUICK_GRENADE]);
	((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_CYCLE_WEAPON]);
	((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_LOCK_TARGET]);
	((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_CYCLE_TARGET]);
	((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_ROTATE_LEFT]);
	((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_ROTATE_RIGHT]);
	
	((InputWidget*)uiManager->getWidget("status", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_STATUS]);
	((InputWidget*)uiManager->getWidget("pause", "controlConfig"))->setValue(INPUT_JOY, game->joystick[CTRL_PAUSE]);
	
	((Slider*)uiManager->getWidget("analogDeadZone", "controlConfig"))->value = game->joystickDeadZone;
}

void populateKeyboardControls()
{
	debug(("populateKeyboardControls()\n"));
	
	((InputWidget*)uiManager->getWidget("left", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_LEFT]);
	((InputWidget*)uiManager->getWidget("right", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_RIGHT]);
	((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_UP]);
	((InputWidget*)uiManager->getWidget("back", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_DOWN]);
	((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_FIRE]);
	((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_JUMP]);
	((InputWidget*)uiManager->getWidget("action", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_ACTION]);
	
	((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_QUICK_GRENADE]);
	((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_CYCLE_WEAPON]);
	((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_LOCK_TARGET]);
	((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_CYCLE_TARGET]);
	((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_ROTATE_LEFT]);
	((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_ROTATE_RIGHT]);
	
	((InputWidget*)uiManager->getWidget("status", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_STATUS]);
	((InputWidget*)uiManager->getWidget("pause", "controlConfig"))->setValue(INPUT_KEY, game->keyboard[CTRL_PAUSE]);
}

void applyMouseControls()
{
	debug(("applyMouseControls()\n"));
	
	game->mouseCtrl[CTRL_LEFT] = ((InputWidget*)uiManager->getWidget("left", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_RIGHT] = ((InputWidget*)uiManager->getWidget("right", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_UP] = ((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_DOWN] = ((InputWidget*)uiManager->getWidget("back", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_FIRE] = ((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_JUMP] = ((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_ACTION] = ((InputWidget*)uiManager->getWidget("action", "controlConfig"))->value[INPUT_MOUSE];
	
	game->mouseCtrl[CTRL_QUICK_GRENADE] = ((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_CYCLE_WEAPON] = ((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_LOCK_TARGET] = ((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_CYCLE_TARGET] = ((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_ROTATE_LEFT] = ((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_ROTATE_RIGHT] = ((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->value[INPUT_MOUSE];
	
	game->mouseCtrl[CTRL_STATUS] = ((InputWidget*)uiManager->getWidget("status", "controlConfig"))->value[INPUT_MOUSE];
	game->mouseCtrl[CTRL_PAUSE] = ((InputWidget*)uiManager->getWidget("pause", "controlConfig"))->value[INPUT_MOUSE];
	
	game->mouseSensitivity = 1000 - (int)((Slider*)uiManager->getWidget("mouseSensitivity", "controlConfig"))->value;
}

void applyJoystickControls()
{
	debug(("applyJoystickControls()\n"));
	
	game->joystick[CTRL_LEFT] = ((InputWidget*)uiManager->getWidget("left", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_RIGHT] = ((InputWidget*)uiManager->getWidget("right", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_UP] = ((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_DOWN] = ((InputWidget*)uiManager->getWidget("back", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_FIRE] = ((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_JUMP] = ((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_ACTION] = ((InputWidget*)uiManager->getWidget("action", "controlConfig"))->value[INPUT_JOY];
	
	game->joystick[CTRL_QUICK_GRENADE] = ((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_CYCLE_WEAPON] = ((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_LOCK_TARGET] = ((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_CYCLE_TARGET] = ((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_ROTATE_LEFT] = ((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_ROTATE_RIGHT] = ((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->value[INPUT_JOY];
	
	game->joystick[CTRL_STATUS] = ((InputWidget*)uiManager->getWidget("status", "controlConfig"))->value[INPUT_JOY];
	game->joystick[CTRL_PAUSE] = ((InputWidget*)uiManager->getWidget("pause", "controlConfig"))->value[INPUT_JOY];
	
	game->joystickDeadZone = (int)((Slider*)uiManager->getWidget("analogDeadZone", "controlConfig"))->value;
}

void applyKeyboardControls()
{
	debug(("applyKeyboardControls()\n"));
	
	game->keyboard[CTRL_LEFT] = ((InputWidget*)uiManager->getWidget("left", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_RIGHT] = ((InputWidget*)uiManager->getWidget("right", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_UP] = ((InputWidget*)uiManager->getWidget("forward", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_DOWN] = ((InputWidget*)uiManager->getWidget("back", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_FIRE] = ((InputWidget*)uiManager->getWidget("fire", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_JUMP] = ((InputWidget*)uiManager->getWidget("jump", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_ACTION] = ((InputWidget*)uiManager->getWidget("action", "controlConfig"))->value[INPUT_KEY];
	
	game->keyboard[CTRL_QUICK_GRENADE] = ((InputWidget*)uiManager->getWidget("grenade", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_CYCLE_WEAPON] = ((InputWidget*)uiManager->getWidget("cycleWeapon", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_LOCK_TARGET] = ((InputWidget*)uiManager->getWidget("lockTarget", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_CYCLE_TARGET] = ((InputWidget*)uiManager->getWidget("cycleTarget", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_ROTATE_LEFT] = ((InputWidget*)uiManager->getWidget("rotateLeft", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_ROTATE_RIGHT] = ((InputWidget*)uiManager->getWidget("rotateRight", "controlConfig"))->value[INPUT_KEY];
	
	game->keyboard[CTRL_STATUS] = ((InputWidget*)uiManager->getWidget("status", "controlConfig"))->value[INPUT_KEY];
	game->keyboard[CTRL_PAUSE] = ((InputWidget*)uiManager->getWidget("pause", "controlConfig"))->value[INPUT_KEY];
}

int doGameOver()
{
	audio->fadeMusic();
	
	float fadeOut = 0;
	
	int rtn = SECTION_LOAD;
	
	uiManager->onlyShowGroup("gameOverWidgets");
	
	Grid *grid = uiManager->getGrid("GameOverGrid");
	
	bool showWidgets = false;
	bool finished = false;
	
	Texture *gameOver = textureManager->getTexture("GameOver");
	
	Button *reload = (Button*)uiManager->getWidget("Reload", "gameOverWidgets");
	Button *load = (Button*)uiManager->getWidget("Load", "gameOverWidgets");
	Button *quit = (Button*)uiManager->getWidget("Quit", "gameOverWidgets");
	
	if (game->saveSlot == -1)
	{
		reload->setEnabled(false);
	}
	
	particleManager->particleList.clear();
	
	engine->slowLogic = true;
	
	while (!finished)
	{
		engine->doTimeDifference();
		
		graphics->updateScreen();
		engine->getInput();
		
		graphics->clearScreen();
		
		if (!showWidgets)
		{
			doGameObjects();
			
			doPlayer();
			
			showWidgets = (fadeOut >= 1.25);
		}
		
		graphics->setMode(MODE_2D);
		
		if (!showWidgets)
		{
			drawInfoPanel();
		}
		
		fadeOut += engine->getTimeDifference(TD_ANIMATION) * 0.002;
		graphics->fade(fadeOut);
		
		glColor4f(1.0, 1.0, 1.0, fadeOut);
		graphics->blit(gameOver, graphics->screen->w / 2, grid->y - 25, true);
		
		if (showWidgets)
		{
			mouse->setBusy(false);
			
			drawWidgets();
			
			if (reload->wasClicked())
			{
				game->setMissionStatus(MISSION_LOADING);
				game->retrying = true;
				
				finished = true;
			}
			
			if (load->wasClicked())
			{
				if (loadGame())
				{
					game->setMissionStatus(MISSION_LOADING);
				}
			
				finished = true;
			}
			
			if (quit->wasClicked())
			{
				rtn = SECTION_TITLE;
				finished = true;
				graphics->clearScreen();
				graphics->updateScreen();
			}
		}
		
		if (engine->userAccepts())
		{
			showWidgets = true;
		}
	}
	
	return rtn;
}

void doControlOptions()
{
	uiManager->onlyShowGroup("controlConfig");
	
	Grid *grid = uiManager->getGrid("ControlConfigGrid");
	
	bool finished = false;
	
	engine->resetTimeDifference();
	
	populateJoystickControls();
	populateKeyboardControls();
	populateMouseControls();
	
	Button *done = (Button*)uiManager->getWidget("Done", "controlConfig");
	Button *reset = (Button*)uiManager->getWidget("Reset", "controlConfig");
	Button *cancel = (Button*)uiManager->getWidget("Cancel", "controlConfig");
	
	int lx = grid->x + 10;
	int lx2 = lx + grid->width - 20;
	int ly = grid->y + grid->height - 55;
	
	while (!finished)
	{
		engine->doTimeDifference();
		
		graphics->updateScreen();
		engine->getInput();
		
		graphics->clearScreen();
		
		graphics->setMode(MODE_3D);
		
		doGameObjects();
		
		graphics->setMode(MODE_2D);
		
		graphics->fade(0.5);
		
		graphics->fade(0.65, grid->x, grid->y, grid->width, grid->height);
		graphics->outlineRect(grid->x, grid->y, grid->width, grid->height, GLColor::lightGrey);
		
		graphics->drawLine(lx, ly, lx2, ly, GLColor::white);
		
		drawWidgets();
		
		if (done->wasClicked())
		{
			applyJoystickControls();
			applyKeyboardControls();
			applyMouseControls();
			finished = true;
		}
		
		if (reset->wasClicked())
		{
			populateJoystickControls();
			populateKeyboardControls();
			populateMouseControls();
		}
		
		if (cancel->wasClicked())
		{
			finished = true;
		}
	}
}

void doConfigOptions()
{
	uiManager->onlyShowGroup("configPanel");
	
	Grid *grid = uiManager->getGrid("ConfigurationGrid");
	
	Button *done = (Button*)uiManager->getWidget("Done", "configPanel");
	Button *controlConfig = (Button*)uiManager->getWidget("ControlConfig", "configPanel");
	ComboBox *resolution = (ComboBox*)uiManager->getWidget("Resolution", "configPanel");
	CheckBox *fullscreen = (CheckBox*)uiManager->getWidget("FullScreen", "configPanel");
	CheckBox *grabMouse = (CheckBox*)uiManager->getWidget("GrabMouse", "configPanel");
	Slider *soundVolume = (Slider*)uiManager->getWidget("SoundVolume", "configPanel");
	Slider *musicVolume = (Slider*)uiManager->getWidget("MusicVolume", "configPanel");
	Slider *ambientVolume = (Slider*)uiManager->getWidget("AmbientVolume", "configPanel");
	Slider *environmentVolume = (Slider*)uiManager->getWidget("EnvironmentVolume", "configPanel");
	
	Button *cheats = (Button*)uiManager->getWidget("Cheats", "configPanel");
	cheats->setVisible(false);
	
	bool finished = false;
	
	fullscreen->checked = graphics->fullscreen;
	grabMouse->checked = mouse->grab;
	soundVolume->value = audio->soundVolume;
	musicVolume->value = audio->musicVolume;
	ambientVolume->value = audio->ambientVolume;
	environmentVolume->value = audio->environmentVolume;
	
	String *res;
	
	for (int i = 0 ; i < 10 ; i++)
	{
		if (graphics->screenMode[i].w == 0)
		{
			continue;
		}
		
		res = new String();
		res->setText("%d x %d", graphics->screenMode[i].w, graphics->screenMode[i].h);
		resolution->addItem(res);
	}
	
	resolution->setSelectedItem(graphics->currentScreenResolution);
	
	engine->resetTimeDifference();
	
	while (!finished)
	{
		engine->doTimeDifference();
		
		graphics->updateScreen();
		engine->getInput();
		
		graphics->clearScreen();
		
		graphics->setMode(MODE_3D);
		
		doGameObjects();
		
		graphics->setMode(MODE_2D);
		
		graphics->fade(0.5);
		
		graphics->fade(0.65, grid->x, grid->y, grid->width, grid->height);
		graphics->outlineRect(grid->x, grid->y, grid->width, grid->height, GLColor::lightGrey);
		
		drawWidgets();
		
		if (resolution->hasChanged())
		{
			graphics->setResolution(resolution->selectedItem);
			uiManager->recalculateWidgetPositions();
		}
		
		if (fullscreen->wasClicked())
		{
			graphics->fullscreen = !graphics->fullscreen;
			SDL_WM_ToggleFullScreen(graphics->screen);
		}
		
		if (soundVolume->hasChanged())
		{
			audio->setSoundVolume((int)soundVolume->value);
		}
		
		if (musicVolume->hasChanged())
		{
			audio->setMusicVolume((int)musicVolume->value);
		}
		
		if (ambientVolume->hasChanged())
		{
			audio->setAmbientVolume((int)ambientVolume->value);
		}
		
		if (controlConfig->wasClicked())
		{
			doControlOptions();
			uiManager->onlyShowGroup("configPanel");
			cheats->setVisible(false);
		}
		
		if ((done->wasClicked()) || (engine->keyState[SDLK_ESCAPE]))
		{
			finished = true;
			engine->keyState[SDLK_ESCAPE] = 0;
		}
		
		fullscreen->checked = graphics->fullscreen;
	}
	
	mouse->grab = grabMouse->checked;
	
	resolution->clear();
}

void doInGameOptions()
{
	uiManager->onlyShowGroup("optionPanel");
	
	Grid *grid = uiManager->getGrid("InGameOptionGrid");
	
	Button *load = (Button*)uiManager->getWidget("Load", "optionPanel");
	Button *save = (Button*)uiManager->getWidget("Save", "optionPanel");
	Button *options = (Button*)uiManager->getWidget("Options", "optionPanel");
	Button *resume = (Button*)uiManager->getWidget("Resume", "optionPanel");
	Button *quit = (Button*)uiManager->getWidget("Quit", "optionPanel");
	
	save->setEnabled(game->canSaveGame);
	
	graphics->setMode(MODE_2D);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	
	bool finished = false;
	
	mouse->setBusy(false);
	engine->doGameLogic = false;
	
	engine->resetTimeDifference();
	
	while (!finished)
	{
		engine->doTimeDifference();
		
		graphics->updateScreen();
		engine->getInput();
		
		graphics->clearScreen();
		
		graphics->setMode(MODE_3D);
		
		doGameObjects();
		
		graphics->setMode(MODE_2D);
		
		graphics->fade(0.5);
		
		graphics->fade(0.65, grid->x, grid->y, grid->width, grid->height);
		graphics->outlineRect(grid->x, grid->y, grid->width, grid->height, GLColor::lightGrey);
		
		drawWidgets();
		
		if (options->wasClicked())
		{
			doConfigOptions();
			uiManager->onlyShowGroup("optionPanel");
		}
		
		if (load->wasClicked())
		{
			if (loadGame())
			{
				game->setMissionStatus(MISSION_LOADING);
			}
			
			finished = true;
		}
		
		if (save->wasClicked())
		{
			saveGame();
		}
		
		if ((resume->wasClicked()) || (engine->keyState[SDLK_ESCAPE]))
		{
			finished = true;
			engine->keyState[SDLK_ESCAPE] = 0;
		}
		
		if (quit->wasClicked())
		{
			game->setMissionStatus(MISSION_QUITTING);
			
			finished = true;
		}
	}
	
	mouse->setBusy(true);
	engine->doGameLogic = true;
}
