/*
Copyright (C) 2005 Parallel Realities

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "../headers.h"

Camera::Camera()
{
	name = "Camera";
	
	recalcFrustum = true;
	
	q3Target = NULL;
	
	boundingBox.mins.set(-3, -3, -3);
	boundingBox.maxs.set(3, 3, 3);
	updateBoundingBox();
}

Camera::~Camera()
{
}

Camera *Camera::getInstance()
{
	return &instance;
}

void Camera::use()
{
	gluLookAt(
	position.x, position.y, position.z, 
	target.x, target.y, target.z, 
	0.0f, 0.0f, 1.0f);
	
	if (recalcFrustum)
	{
		frustum.calculate();
	}
}

void Camera::updateFrustum()
{
	recalcFrustum = true;
}

bool Camera::containsSphere(Vector position, float radius)
{
	return frustum.containsSphere(position, radius);
}

void Camera::loadAdditional(Properties *props){}
void Camera::saveAdditional(Properties *props){}

Camera Camera::instance;
