/*
Copyright (C) 2005 Parallel Realities

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

class Camera : public Entity {

	private:
		
		bool recalcFrustum;
		
		static Camera instance;
		
	Camera();
	
	public:
		
		Vector target;
		Frustum frustum;
		
		Q3Target *q3Target;

	
	~Camera();
	
	static Camera *getInstance();
	
	void use();
	void updateFrustum();
	
	bool containsSphere(Vector position, float radius);
	
	void loadAdditional(Properties *props);
	void saveAdditional(Properties *props);

};
